#NoTrayIcon
#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=AquariaWin32Dev.ico
#AutoIt3Wrapper_outfile=AQpatch.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

opt("MustDeclareVars", 1)
Opt("GUIOnEventMode", 1)

Global $lvpa = @ScriptDir & "\" & "patchdata.lvpa"
if not FileExists($lvpa) Then
	MsgBox(16, "Error!", $lvpa & " not found")
	Exit
EndIf

Dim $dllname = "aqpatch.dll"
Dim $dll = DllOpen($dllname)
if $dll == -1 Then
	MsgBox(16, "Error!", $dllname & " not found")
	Exit
EndIf

Global $aqdir = RegRead("HKLM\SOFTWARE\BITBLOT_Aquaria", "Install_Dir")
if $aqdir <> "" and (StringRight($aqdir, 1) == "/" or StringRight($aqdir, 1) == "\") Then
	$aqdir = StringTrimRight($aqdir, 1)
EndIf

Global $outdir = ""
if $aqdir <> "" Then
	$outdir = $aqdir & "-1.1.1"
EndIf



Global $Input1, $Input2, $Button2
Global $btnlabel = "Create 1.1.1 installation"

func CreateGUI()
	#Region ### START Koda GUI section ### Form=E:\coding\Aquariamoleboxunpack\Form1.kxf
	Local $Form1 = GUICreate("Aquaria 1.0.x -> 1.1.1 converter", 424, 291, 193, 115)
	GUISetOnEvent($GUI_EVENT_CLOSE, "FormClose")
	Local $Button1 = GUICtrlCreateButton("...", 344, 120, 35, 25, 0)
	GUICtrlSetOnEvent($Button1, "ButtonPathClick")
	$Input1 = GUICtrlCreateInput($aqdir, 32, 120, 297, 21)
	Local $Label1 = GUICtrlCreateLabel("Select Aquaria 1.0.x installation directory:", 32, 96, 197, 17)
	$Button2 = GUICtrlCreateButton($btnlabel, 120, 240, 147, 33, 0)
	GUICtrlSetOnEvent($Button2, "ButtonCreateClick")
	Local $Label2 = GUICtrlCreateLabel("Select output directory:", 32, 168, 113, 17)
	$Input2 = GUICtrlCreateInput($outdir, 32, 192, 297, 21)
	Local $Button3 = GUICtrlCreateButton("...", 344, 192, 35, 25, 0)
	GUICtrlSetOnEvent($Button3, "ButtonOutClick")
	Local $Label3 = GUICtrlCreateLabel("This tool will create a playable Aquaria 1.1.1 installation", 24, 16, 322, 17)
	GUICtrlSetFont($Label3, 8, 800, 0, "MS Sans Serif")
	Local $Label4 = GUICtrlCreateLabel("from an old 1.0.x version.", 24, 32, 148, 17)
	GUICtrlSetFont($Label4, 8, 800, 0, "MS Sans Serif")
	Local $Label5 = GUICtrlCreateLabel("Make sure you have about 250 MB space free.", 24, 56, 317, 17)
	GUICtrlSetFont($Label5, 8, 800, 0, "MS Sans Serif")
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###
EndFunc

CreateGUI()

While 1
	Sleep(100)
WEnd

Func FormClose()
	DllClose($dll)
	Exit
EndFunc

Func ButtonCreateClick()
	GUICtrlSetData($Button2, "Working... please wait.")
	GUICtrlSetState($Button2, $GUI_DISABLE)
	ButtonCreateClick2()
	GUICtrlSetState($Button2, $GUI_ENABLE)
	GUICtrlSetData($Button2, $btnlabel)
EndFunc

Func ButtonCreateClick2()
	$aqdir = GUICtrlRead($Input1)
	$outdir = GUICtrlRead($Input2)
	
	if not FileExists($aqdir & "\data.000") Then
		MsgBox(48, "Wrong directory!", "Looks like you didn't select a correct Aquaria 1.0.3 installation directory, file 'data.000' not found. " & @CRLF & _
		"Note that version 1.1 and up don't have this file anymore, in this case this patch isn't necessary.")
		Return
	EndIf
		
	if DirCreate($outdir) == 0 Then
		MsgBox(16, "Error!", "Failed to create output directory:" & @CRLF & @CRLF & $outdir)
		Exit
	EndIf

	Dim $ret = DllCall($dll, "int:cdecl", "unpackMolebox", "str", $aqdir, "str", $outdir)
	Dim $e = @error
	if $e <> 0 Then
		MsgBox(0, "Error!", "DllCall error " & $e)
		Return
	EndIf

	Dim $res = $ret[0]
	if $res < 0 Then
		MsgBox(48, "Error!", "Failed to unpack molebox container!" & @CRLF & _
		"Make sure this is one of the game versions listed in the readme file." & @CRLF & _
		"Check the suppport section @ http://bit-blot.com/forum for patches.")
		Return
	EndIf

	$ret = DllCall($dll, "int:cdecl", "unpackLVPA", "str", $lvpa, "str", $outdir)
	Dim $e = @error
	if $e <> 0 Then
		MsgBox(0, "Error!", "DllCall error " & $e)
		Return
	EndIf

	Dim $res = $ret[0]
	if $res < 0 Then
		MsgBox(48, "Error!", "Failed to unpack LVPA container!")
		Return
	EndIf
	
	FileCopy($aqdir & "\usersettings.xml", $outdir, 1)
	FileWrite($outdir & "\ran", "1")

	MsgBox(64, "Success!", "Created patched Aquaria-1.1.1 installation in directory:" & @CRLF & @CRLF & $outdir)
EndFunc

Func ButtonOutClick()
	$outdir = GUICtrlRead($Input2)
	Local $d = FileSelectFolder("Select 1.1.1 output directory", "", 6, $outdir)
	if $d <> "" Then
		$outdir = $d
		GUICtrlSetData($Input2, $outdir)
	EndIf
EndFunc

Func ButtonPathClick()
	$aqdir = GUICtrlRead($Input1)
	Local $d = FileSelectFolder("Select 1.0.x installation directory", "", 6, $aqdir & "\")
	if $d <> "" Then
		$aqdir = $d
		GUICtrlSetData($Input1, $aqdir)
	EndIf
EndFunc

